<?php
########################
##
## Origineel
## ---------
## WMThomas: bezoekers teller
##
##
## Herschrijving
## -------------
## ArnoOnline: unieke bezoekers teller
##
## Unieke bezoekers teller welke gebruikt maakt van
## een tekstbestand (geen MySQL) om de data op te
## slaan.
##
##
## Uitbreiding
## -----------
## Kolibrie Software's Jawade: ook IP-log met alles
##
## Mooie toevoeging in de vorm van een log met
## totaal, uniek, tijd en datum, IP en aantal per
## IP. Ook host, provider en land. (07-10-07).
## En op 27-09-2010 ook OS en browser, en het
## nummerformat verbeterd.
##
########################

## Optional settings
$FILENAME = "teller1234.dat";
$FILELOG = "iplog1234.dat";

## Open de database
$oldData = file($FILENAME);

## Initiate variables
$newData      = "";
$totalHits    = 1;
$uniqueHits   = count($oldData);
$knownVisitor = false;

## Examine data
for ($i = 0; $i < count($oldData); $i++)
{
   $currentRecord = explode(" ", $oldData[$i]);
   $totalHits += $currentRecord[1];

   if ($_SERVER['REMOTE_ADDR'] == $currentRecord[0])
   {
      $newData .= $currentRecord[0] . " ". ($currentRecord[1] + 1) . "\n";
      $knownVisitor = true;
      $HpIData = ($currentRecord[1] + 1);
   }
   else
   {
      $newData .= $oldData[$i];
   }
}

if (!$knownVisitor)
{
   $newData .= $_SERVER['REMOTE_ADDR'] . " 1\n";
   $uniqueHits++;
   $HpIData = 1;
}

## Store new data
$logFile = @fopen($FILENAME, 'w');
   fwrite($logFile, $newData);
fclose($logFile);
##echo "|" . $newData . "|";

## Nu Jawade!
if(eregi("(win|windows)[ ]*((nt)*[ /]*([0-9]+(.?[0-9]+))*)", $_SERVER["HTTP_USER_AGENT"]))
{
    if(eregi("(win|windows)[ ](95)", $_SERVER["HTTP_USER_AGENT"]))
    {
        $os = "Win 95";
    }
    elseif(eregi("(win|windows)[ ](9x)[ ](4.90)", $_SERVER["HTTP_USER_AGENT"]))
    {
        $os = "Win ME";
    }
    elseif(eregi("(win|windows)[ ](98)", $_SERVER["HTTP_USER_AGENT"]))
    {
        $os = "Win 98";
    }
    elseif(eregi("(win|windows)[ ](NT)", $_SERVER["HTTP_USER_AGENT"]))
    {
        if(eregi("(win|windows)[ ](NT)[ ](5.1)", $_SERVER["HTTP_USER_AGENT"]))
        {
            $os = "Win XP";
        }
        elseif(eregi("(win|windows)[ ](NT)[ ](5.0)", $_SERVER["HTTP_USER_AGENT"]))
        {
            $os = "Win 2K";
        }
        elseif(eregi("(win|windows)[ ](NT)[ ](6.0)", $_SERVER["HTTP_USER_AGENT"]))
        {
            $os = "WVista";
        }
        elseif(eregi("(win|windows)[ ](NT)[ ](6.1)", $_SERVER["HTTP_USER_AGENT"]))
        {
            $os = "Win. 7";
        }
        else
        {
            $os = "Win NT";
        }
    }
    else
    {
        $os = "Win???";
    }
}
elseif(stristr($_SERVER["HTTP_USER_AGENT"], "Linux"))
{
    $os = "Linux ";
}
elseif(stristr($_SERVER["HTTP_USER_AGENT"], "Unix"))
{
    $os = "Unix  ";
}
elseif(stristr($_SERVER["HTTP_USER_AGENT"], "Mac"))
{
    $os = "MacOs ";
}
elseif(stristr($_SERVER["HTTP_USER_AGENT"], "PPC"))
{
    $os = "MacOs ";
}
elseif(stristr($_SERVER["HTTP_USER_AGENT"], "HP"))
{
    $os = "HPuX  ";
}
elseif(stristr($_SERVER["HTTP_USER_AGENT"], "SunOS"))
{
    $os = "SunOS ";
}
else
{
    $os = "OS=???";
}

$tempvar = strtolower($_SERVER["HTTP_USER_AGENT"]);
$browser = "Browser=???";
if (eregi('bot', $tempvar)) { $browser = "Zoekmach"; }
if (eregi('opera/([0-9]+\.[0-9]+)', $tempvar, $regs)) { $browser = "Opera   ".$regs[1]; }
if (eregi('lynx/([0-9]+\.[0-9]+\.[0-9]+)', $tempvar, $regs)) { $browser = "Lynx    ".$regs[1]; }
if (eregi('netscape6/([0-9]+\.[0-9]+\.[0-9]+)', $tempvar, $regs)) { $browser = "Netscap ".$regs[1]; }
if (eregi('mozilla/([0-9]+\.[0-9]+)', $tempvar, $regs)) { $browser = "Mozilla ".$regs[1]; }
if (eregi('firefox/([0-9]{0,2}\.[0-9]{0,2}\.[0-9]{0,2})', $tempvar, $regs)) { $browser = "Mozi.FF ".$regs[1]; }
if (eregi('msie ([0-9]+\.[0-9]+)', $tempvar, $regs)) { $browser = "MS IExp ".$regs[1]; }

##$host_names = explode(".", gethostbyaddr($REMOTE_ADDR));
$host_names = explode(".", gethostbyaddr($_SERVER["REMOTE_ADDR"]));

#### Test dump ##################################
##$logFile = @fopen($FILELOG, "a");
##   if ($logFile)
##   {
##      fwrite($logFile, $host_names[0] . " ~ ");
##      fwrite($logFile, $host_names[1] . " ~ ");
##      fwrite($logFile, $host_names[2] . " ~ ");
##      fwrite($logFile, $host_names[3] . " ~ ");
##      fwrite($logFile, $host_names[4] . " ~ ");
##      fwrite($logFile, $host_names[5] . " ~ ");
##      fwrite($logFile, $host_names[6] . " ~ ");
##      fwrite($logFile, $host_names[7] . "\n");
##   }
##fclose($logFile);
#################################################

$logFile = @fopen($FILELOG, "a");
   if ($logFile)
   {
      fwrite($logFile, number_format($totalHits, 0, ',', '.') . " ");
      fwrite($logFile, number_format($uniqueHits, 0, ',', '.') . "  ");
      fwrite($logFile, date("d-m-Y H:i:s", time()) . "  ");
      $a = $_SERVER['REMOTE_ADDR'];
      $a = $a . " (" . $HpIData . "x)";
      do
      {
         $a = $a ." ";
      }
      while (strlen($a) != 24);
      fwrite($logFile, $a);
      fwrite($logFile, $os . "  ");
      fwrite($logFile, $browser);
      foreach ($host_names as $hostname)
      {
         fwrite($logFile, "  " . $hostname);
      }
      fwrite($logFile, "\n");
   }
fclose($logFile);

## Show results, ## weg voor weergave.
##echo("Totaal: {$totalHits}");
##echo("<p>");
##echo("Uniek: {$uniqueHits}");
?>
